image: docker:latest
stages:
- quality-code
- build
- test
- deploy

pylint:
  stage: quality-code
  image: 
    name: python:3.6
    entrypoint: [""]
  before_script:
    - pip install pylint
  script:
    - pylint --recursive=y ./core --output-format=json:artifacts/reports/report-lint.json,colorized || true
  artifacts:
    paths:
      - "./artifacts/reports"
    when: on_success
    access: all
    expire_in: 2 hrs  

dockerfile-scanner:
  stage: quality-code
  dependencies:
    - "pylint"
  image: 
    name: aquasec/trivy:latest
    entrypoint: [""]
  script:
    - trivy config .
  allow_failure: true
  only:
    - master

sonar-scanner:
  stage: quality-code
  image: 
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  
    GIT_DEPTH: "0"   
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script: 
    - sonar-scanner
  allow_failure: true
  only:
    - master
    
build-docker:
  stage: build
  image:
    name: docker:latest
  services:
  - docker:20.10.9-dind
  before_script:
  # - echo $COSIGN_PRIVATE_KEY > cosign.key
  # - apk add dos2unix
  # - dos2unix cosign.key
  # - apk add curl
  # - curl -O -L "https://github.com/sigstore/cosign/releases/latest/download/cosign-linux-amd64"
  # - mv cosign-linux-amd64 /usr/local/bin/cosign
  # - chmod +x /usr/local/bin/cosign
  - echo "$CI_REGISTRY_PASSWORD" | docker login $CI_REGISTRY -u $CI_REGISTRY_USER --password-stdin
  script:
  - docker build -t registry.gitlab.com/vinicius.alcantara/estudogitlabcialura:$CI_COMMIT_SHA .
  - docker push registry.gitlab.com/vinicius.alcantara/estudogitlabcialura:$CI_COMMIT_SHA
  # - cosign sign --key cosign.key registry.gitlab.com/vinicius.alcantara/estudogitlabcialura:$CI_COMMIT_SHA

image-signature:
  stage: build
  dependencies:
    - "build-docker"
  image:
    name: docker:latest
  before_script:
  - sleep 120
  - echo $COSIGN_PRIVATE_KEY | base64 -d > cosign.key
  - apk add curl
  - curl -O -L "https://github.com/sigstore/cosign/releases/latest/download/cosign-linux-amd64"
  - mv cosign-linux-amd64 /usr/local/bin/cosign
  - chmod +x /usr/local/bin/cosign
  script:
  - yes | cosign sign --key cosign.key registry.gitlab.com/vinicius.alcantara/estudogitlabcialura:$CI_COMMIT_SHA
  
image-scanner:
  stage: build
  image: 
    name: aquasec/trivy:latest
    entrypoint: [""]
  script:
    - trivy image --scanners vuln,secret,license viniciusalcantara2018/bytebank:latest --format table --output artifacts/reports/gitlab_trivy_report.md
  cache:
    paths:
      - "./artifacts/cache/"
  artifacts:
    when: always
    paths:
      - "./artifacts/reports/"
    reports:
      dependency_scanning: artifacts/reports/gitlab_trivy_report.md
    expire_in: 2 hrs
  retry: 2
  allow_failure: false
  only:
    - master

test-project:
  stage: test
  image: viniciusalcantara2018/bytebank:latest
  script:
  - python -m unittest setUp 

deploy-project:
  stage: deploy
  dependencies:
  - test-project
  before_script: 
  - mkdir ~/.ssh
  - echo $SSH_SERVER_KEY | base64 -d > ~/.ssh/id_rsa
  - chmod 400 ~/.ssh/id_rsa  
  - ssh-keyscan $SERVER_HOST >> ~/.ssh/known_hosts
  - eval $(ssh-agent)
  - ssh-add ~/.ssh/id_rsa
  script:
  - tar cfz arquivos.tgz *
  - scp -o StrictHostKeyChecking=no arquivos.tgz $SERVER_USER@$SERVER_HOST:/usr/local/share/deploy 2> /dev/null
  - ssh -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_HOST "cd /usr/local/share/deploy && sudo tar -xzf arquivos.tgz && sudo docker-compose up -d && sudo rm -f arquivos.tgz" 2> /dev/null